<template  >
  <div>
    <div class="pagination">

    <Pagination
      v-show="total > 0"
      :total="total"
      :page.sync="page"
      :limit.sync="limit"
      @pagination="jumpToPage"
    />
    </div>
    <br>
    <br />
    <component :is="table" :data="data" :apiParams="apiParams" />
    <br>
    <br>
  </div>
</template>
<script>
import { mapState } from "vuex";
import Pagination from "./Pagination";
import RepoTable from "./RepoTable";
export default {
  name: "GenericTable",
  props: ["table", "apiParams"],
  components: {
    Pagination,
    RepoTable,
  },
  computed: {
    ...mapState({
      data: (state) => state.tableData,
      total: (state) => state.total,
    }),
    page: {
      get() {
        return this.$store.state.query.page;
      },
      set(value) {
        this.$store.commit("UPDATE_PAGE", value);
      },
    },
    limit: {
      get() {
        return this.$store.state.query.limit;
      },
      set(value) {
        this.$store.commit("UPDATE_LIMIT", value);
      },
    },
  },
  filters: {
    modify: function (labels) {
      //TODO not being called?
      const result = [];
      const keyValue = (input) =>
        Object.entries(input).forEach(([key, value]) => {
          var str = key + ": " + value;
          result.push(str);
          return result;
        });
      keyValue(labels);
      var data = result.toString();
      let dataToArray = data.split(",").map((item) => item.trim());
      return dataToArray.join("\n");
    },
  },
  methods: {
    jumpToPage() {
      if (document.body.contains(this.$el))
        this.$store.dispatch("getSearchResults", this.apiParams);
    },
  },
};
</script>
<style scoped>
.pagination{
  align-items: center;
}
</style>
